#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, a, b;
    scanf("%d", &n);
    vector<int> tezine(n);
    for(int i = 0; i < n; i++) {
        scanf("%d", &tezine[i]);
    }
    for(int i = 0; i < n - 1; i++) {
        scanf("%d %d", &a, &b);
        a--;
        b--;
    }
    printf("%d\n%d\n", tezine[0], 1);
    printf("1\n");
    printf("0\n");
    return 0;
}